#include <bits/stdc++.h>

using namespace std;
using ll = long long;
vector<vector<int>> a;
vector<int> dist;
vector<int> cnt;

void dfs(int v) {
    cnt[v] = 1;
    for (int u: a[v]) {
        if (cnt[u] == 0) {
            dist[u] = min(dist[u], dist[v] + 1);
            dfs(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    if (k != 1|| n > 2000) {
        int h = 0;
        if (n % (k + 1) != 0) {
            h++;
        }
        cout << n / (k + 1) + h;
        return 0;
    }
    a.resize(n + 1);
    dist.resize(n + 1, 99999999);
    cnt.resize(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        int c, b;
        cin >> c >> b;
        a[c].push_back(b);
        a[b].push_back(c);
    }
    int ans = 9999999;
    for (int i = 2; i <= n; ++i) {
        dist[1] = 0;
        dist[i] = 1;
        dfs(1);
        int u = 0;
        for (int j = 2; j <= n; ++j) {
            u = max(u, dist[j]);
        }
        std::fill(dist.begin(), dist.end(), 9999999);
        std::fill(cnt.begin(), cnt.end(), 0);
        ans = min(u, ans);
    }
    cout << ans;
}