#include <bits/stdc++.h>

using namespace std;
using ll = long long;
vector<vector<int>> a;
vector<ll> dist;
vector<ll> s;
vector<int> cnt;
ll ans = 24824842932;
multiset<ll> tr;

ll dfs(int v) {
    cnt[v] = 1;
    for (int u: a[v]) {
        if (cnt[u] == 0) {
            dist[v] = max(dist[v], dfs(u));
        }
    }
    ans = min(dist[v] + 1, ans);
    return dist[v] + 1;
}

ll fs(int v, int d = 0) {
    cnt[v] = 1;
    s[v] = d;
    for (int u: a[v]) {
        if (cnt[u] == 0) {
            fs(u, d + 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    if (k != 1 || n > 2000) {
        int h = 0;
        if (n % (k + 1) != 0) {
            h++;
        }
        cout << n / (k + 1) + h;
        return 0;
    }
    a.resize(n + 1);
    dist.resize(n + 1);
    cnt.resize(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        int c, b;
        cin >> c >> b;
        a[c].push_back(b);
        a[b].push_back(c);
    }
    fs(1);
    std::fill(cnt.begin(), cnt.end(), 0);
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        tr.insert(s[i]);
    }
    for (int i = 2; i <= n; ++i) {
        tr.erase(s[i]);
        tr.insert(dist[i] + 1);
        ll u = *tr.end() - 1;
        ans = min(ans, u);
        tr.insert(s[i]);
        tr.erase(dist[i] + 1);
    }
    ans = 0;
    if (n % (k + 1) != 0) {
        ans++;
    }
    cout << n / (k + 1) + ans;
}